class DrawData{

  XMLdata songdatas;
  Particle p1;
  //ArrayList particles;

  PImage img;
  PImage shadow_msk;
  float amp;

  float x, y1, y2, y3, z1, z2, z3, r; 
  
  int currentSegmentIndex;
  int currentSegmentIndex2;
  
  color col;

  DrawData(XMLdata datas, PImage img_, PImage shadow_msk_){

    songdatas = datas;
    amp = 1;
    img = img_;
    shadow_msk = shadow_msk_;
     
    // particles = new ArrayList();  //initialize the arraylist 
  }

  void addPS(Vector3D loc, float r,  color col){
   // color col = color (255, 0, 0, 100);
    p1= new Particle(loc, r,img, shadow_msk, col, amp);
    p1.drawShadow();
    p1.run();
    
  }


  void setParticles(float b){

    amp = (b*100)%30;
    currentSegmentIndex = 0;
    
    int temp = songdatas.numSegments; 

    for(int i=0; i< songdatas.stTime.length;i++){
      
      float temp_z = ((songdatas.durationSeg[currentSegmentIndex]*(-5000))/3);
      x = map( songdatas.stTime[currentSegmentIndex], 0 , songdatas.stTime[temp-1], (width-winSizeX)/2, (width-winSizeX)/2+winSizeX);  
      
      //particle size
      r = map( songdatas.stTime[currentSegmentIndex], 0 , songdatas.durationSeg[temp-1], 2, 100);  
      
      //   x = map( songdatas.stTime[currentSegmentIndex], 0 , songdatas.stTime[temp-1], sin, (width-winSizeX)/2+winSizeX);
      y1 =  map( songdatas.loudness[currentSegmentIndex][0], songdatas.minLoud_at_Begin, songdatas.maxLoud_at_Begin, (height-winSizeY)/2+winSizeY, (height-winSizeY)/2);
      y2=  map( songdatas.loudness[currentSegmentIndex][1], songdatas.minLoud_at_Begin, songdatas.maxLoud_at_Begin, (height-winSizeY)/2+winSizeY, (height-winSizeY)/2);
      y3 =  map( songdatas.loudness[currentSegmentIndex][2], songdatas.minLoud_at_Begin, songdatas.maxLoud_at_Begin, (height-winSizeY)/2+winSizeY, (height-winSizeY)/2);

      z1 = temp_z;
      z2 = temp_z*2;
      z3 = temp_z*3;

      Vector3D loc1 = new Vector3D(x,y1,z1); 
      Vector3D loc2 = new Vector3D(x,y2,z2);
      Vector3D loc3 = new Vector3D(x,y3,z3);
     
      drawText(currentSegmentIndex,x,y1, z1);
      drawText(currentSegmentIndex,x,y2, z3);
      drawText(currentSegmentIndex,x,y3, z2);
    
      col = setCol(y1, y2, y3); //set color by loudness 
      addPS(loc1, r%30, setCol(y1, y2, y3)); //set particles 
      addPS(loc2, r%30, setCol(y1, y2, y3));
      addPS(loc3, r%30,  setCol(y1, y2, y3));
     
      connectLine(x, y1, z1, x, y2, z2 );
      connectLine(x, y2, z2, x, y3, z3);
      
      if(currentSegmentIndex< songdatas.stTime.length-1){
        currentSegmentIndex++;
      }
   strokeWeight(0.01);

    }
  }


 

  color setCol(float r_, float g_, float b_){

    float r = (abs(r_)*100)%255; //red
    float g = (abs(g_)*100)%255; //green
    float b =(abs(b_)*100)%255; //blue

    col =color(r, g, b);
    return color(r, g, b);

  }

  void drawText(int index, float x, float y, float z){
    fill(255,40);
    text(index, x, (height-winSizeY)/2+winSizeY, z);
   //  text(index, x, y, z);
  }

  void connectLine(float x1, float y1, float z1, float x2, float y2, float z2){
   // stroke(col);
    stroke(255,255,255, 10);
    strokeWeight(0.01);
    
    float temp = abs(y2-y1)/2;
    float tempPos1;

    if(temp < (winSizeY/2)){
      tempPos1 = height/2 + abs(y2-y1)/2;
    }
    else{
      tempPos1 =  (height-winSizeY)/2 + abs(y2-y1)/2;
    }

  
    noFill();
   // if(drawLine){
     
    beginShape();
    curveVertex(x1, y1, z1);
    curveVertex(x1, y1, z1);
    curveVertex(x1, height/2+ abs(y2-y1)/2, z1+((abs(z2) -abs(z1))/2*-1));
    curveVertex(x1, (height-winSizeY)/2 + abs(y2-y1)/2, z1+((abs(z2) -abs(z1))/2*-1));
    curveVertex(x2, y2, z2);
    curveVertex(x2, y2, z2);
    endShape();
   // }
    
  }
  
 void drawCircle(float x, float y, float z, float r){
  
   stroke(col, 10);
   strokeWeight(0.1);
    pushMatrix();
    noFill();
    translate(x, y, z);
    rotateY(90);
    ellipse(0, 0, r, r);
    popMatrix();
    
    pushMatrix();
    noFill();
    translate(x, y, z);
    rotateX(90);
    ellipse(0, 0, r, r);
    popMatrix();
  }
  
}
